declare default element namespace 'http://пф.рф/ВС/СЗВ-М/2016-06-21';declare namespace УТ = "http://пф.рф/унифицированныеТипы/2014-01-01";
declare namespace АФ = "http://пф.рф/АФ";
declare namespace АФ2 = "http://пф.рф/АФ/2016-06-21";
declare variable $document as node()* external;
declare variable $root:=root($document)/ЭДПФР;
declare variable $szv:=$root/СЗВ-М;
declare variable $innArray:=$szv/СписокЗЛ//ИНН;
declare function local:nodeIndex($nodes as node()*, $nodeToFind as node()) as xs:integer
{

				for $seq in (1 to count($nodes))
				return $seq[$nodes[$seq] is $nodeToFind]
			
};
declare function local:nodePosition($node as node()?) as xs:string
{

				string-join(
					for $ancestor in $node/ancestor-or-self::*
					let $sibsOfSameName := $ancestor/../*[name()=name($ancestor)]
					return concat(name($ancestor),
						if (count($sibsOfSameName)<= 1) then '' else concat('[',local:nodeIndex($sibsOfSameName,$ancestor),']')),
						'/'
				)
			
};
declare function local:all-whitespace($arg as xs:string?) as xs:boolean
{

				normalize-space($arg) = ''
			
};
declare function local:isEmpty($element) as xs:boolean
{

				local:all-whitespace(string($element))
			
};
declare function local:notExistsOrEmpty($element) as xs:boolean
{

				not(exists($element)) or local:isEmpty($element)
			
};
declare function local:repeat-string($stringToRepeat as xs:string?, $count as xs:integer) as xs:string
{

				string-join((for $i in 1 to $count return $stringToRepeat),'')
			
};
declare function local:pad-integer-to-length($integerToPad as xs:anyAtomicType?, $length as xs:integer) as xs:string
{

				concat(local:repeat-string('0',$length - string-length(string($integerToPad))),string($integerToPad))
			
};
<БлокПроверок ID="ВСЗЛ.СЗВ-М.1" name="Блок проверок реестр застрахованных лиц">
<Проверка ID="2">
<Описание>Элемент ИНН застрахованного лица должен быть заполнен</Описание>
<РезультатЗапроса>
{
				for $zl in $szv/СписокЗЛ/ЗЛ
					return if (not(local:notExistsOrEmpty($zl/ИНН))) then '0'
					else local:nodePosition($zl)
			}
</РезультатЗапроса>
<КодРезультата>20</КодРезультата>
</Проверка>
<Проверка ID="3">
<Описание>Период представления СЗВ-М должен быть не ранее апреля 2016 года</Описание>
<РезультатЗапроса>
{
				let $month := local:pad-integer-to-length(xs:string($szv/ОтчетныйПериод/Месяц), 2)
				let $year := xs:string($szv/ОтчетныйПериод/КалендарныйГод)
				let $limitDate := xs:date('2016-04-01')
				return if (xs:date(concat($year,'-',$month,'-01')) < $limitDate) then local:nodePosition($szv/ОтчетныйПериод)
					else '0'
			}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="4">
<Описание>Для всех типов форм СЗВ-М отчетный период, за который подается форма, должен быть меньше либо равен месяцу, в котором проводится проверка</Описание>
<РезультатЗапроса>
{
				let $month := local:pad-integer-to-length(xs:string($szv/ОтчетныйПериод/Месяц), 2)
				let $year := xs:string($szv/ОтчетныйПериод/КалендарныйГод)
				let $limitDate := current-date()
				return if (xs:date(concat($year,'-',$month,'-01')) <= $limitDate) then '0'
					else local:nodePosition($szv/ОтчетныйПериод)
			}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
</БлокПроверок>

